Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/GaussPoints.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/GaussPoints.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/GaussPoints.cpp	(revision 12878)
@@ -1220,86 +1220,86 @@
 	/*Intermediaries*/
 	int i,j,k,ipt,nigaus;
-	double xi,eta,zeta;
-	double *xgaus=NULL,*xwgt=NULL,*egaus,*ewgt,*zgaus,*zwgt;
+	IssmPDouble xi,eta,zeta;
+	IssmPDouble *xgaus=NULL,*xwgt=NULL,*egaus,*ewgt,*zgaus,*zwgt;
 
 	/*Hardcoded Gauss points definition*/
-	/*p= 1, npoint= 1  {{{2*/
-	static double wgt1[]={
+	/*p= 1, npoint= 1  {{{*/
+	static IssmPDouble wgt1[]={
 		1.000000000000000};
-	static double l11[]={
+	static IssmPDouble l11[]={
 		0.250000000000000};
-	static double l21[]={
+	static IssmPDouble l21[]={
 		0.250000000000000};
-	static double l31[]={
+	static IssmPDouble l31[]={
 		0.250000000000000};
-	static double l41[]={
+	static IssmPDouble l41[]={
 		0.250000000000000};
-	/*}}}2*/
-	/*p= 2, npoint= 4  {{{2*/
-
-	static double wgt2[]={
+	/*}}}*/
+	/*p= 2, npoint= 4  {{{*/
+
+	static IssmPDouble wgt2[]={
 		0.250000000000000, 0.250000000000000, 0.250000000000000,
 		0.250000000000000};
-	static double l12[]={
+	static IssmPDouble l12[]={
 		0.585410196624969, 0.138196601125011, 0.138196601125011,
 		0.138196601125011};
-	static double l22[]={
+	static IssmPDouble l22[]={
 		0.138196601125011, 0.585410196624969, 0.138196601125011,
 		0.138196601125011};
-	static double l32[]={
+	static IssmPDouble l32[]={
 		0.138196601125011, 0.138196601125011, 0.585410196624969,
 		0.138196601125011};
-	static double l42[]={
+	static IssmPDouble l42[]={
 		0.138196601125011, 0.138196601125011, 0.138196601125011,
 		0.585410196624969};
-	/*}}}2*/
-	/*p= 3, npoint= 5  {{{2*/
-	static double wgt3[]={
+	/*}}}*/
+	/*p= 3, npoint= 5  {{{*/
+	static IssmPDouble wgt3[]={
 		-0.800000000000000, 0.450000000000000, 0.450000000000000, 
 		0.450000000000000, 0.450000000000000};
-	static double l13[]={
+	static IssmPDouble l13[]={
 		0.250000000000000, 0.500000000000000, 0.166666666666667, 
 		0.166666666666667, 0.166666666666667};
-	static double l23[]={
+	static IssmPDouble l23[]={
 		0.250000000000000, 0.166666666666667, 0.500000000000000, 
 		0.166666666666667, 0.166666666666667};
-	static double l33[]={
+	static IssmPDouble l33[]={
 		0.250000000000000, 0.166666666666667, 0.166666666666667, 
 		0.500000000000000, 0.166666666666667};
-	static double l43[]={
+	static IssmPDouble l43[]={
 		0.250000000000000, 0.166666666666667, 0.166666666666667, 
 		0.166666666666667, 0.500000000000000};
-	/*}}}2*/
-	/*p= 4, npoint=11  {{{2*/
-
-	static double wgt4[]={
+	/*}}}*/
+	/*p= 4, npoint=11  {{{*/
+
+	static IssmPDouble wgt4[]={
 		-0.013155555555556, 0.007622222222222, 0.007622222222222, 
 		0.007622222222222, 0.007622222222222, 0.024888888888889,
 		0.024888888888889, 0.024888888888889, 0.024888888888889, 
 		0.024888888888889, 0.024888888888889};
-	static double l14[]={
+	static IssmPDouble l14[]={
 		0.250000000000000, 0.785714285714286, 0.071428571428571, 
 		0.071428571428571, 0.071428571428571, 0.399403576166799,
 		0.399403576166799, 0.399403576166799, 0.100596423833201, 
 		0.100596423833201, 0.100596423833201};
-	static double l24[]={
+	static IssmPDouble l24[]={
 		0.250000000000000, 0.071428571428571, 0.785714285714286, 
 		0.071428571428571, 0.071428571428571, 0.399403576166799,
 		0.100596423833201, 0.100596423833201, 0.399403576166799, 
 		0.399403576166799, 0.100596423833201};
-	static double l34[]={
+	static IssmPDouble l34[]={
 		0.250000000000000, 0.071428571428571, 0.071428571428571, 
 		0.785714285714286, 0.071428571428571, 0.100596423833201, 
 		0.399403576166799, 0.100596423833201, 0.399403576166799,
 		0.100596423833201, 0.399403576166799};
-	static double l44[]={
+	static IssmPDouble l44[]={
 		0.250000000000000, 0.071428571428571, 0.071428571428571, 
 		0.071428571428571, 0.785714285714286, 0.100596423833201, 
 		0.100596423833201, 0.399403576166799, 0.100596423833201,
 		0.399403576166799, 0.399403576166799};
-	/*}}}2*/
-	/*p= 5, npoint=15  {{{2*/
-
-	static double wgt5[]={
+	/*}}}*/
+	/*p= 5, npoint=15  {{{*/
+
+	static IssmPDouble wgt5[]={
 		0.030283678097089, 0.006026785714286, 0.006026785714286, 
 		0.006026785714286, 0.006026785714286, 0.011645249086029, 
@@ -1307,5 +1307,5 @@
 		0.010949141561386, 0.010949141561386, 0.010949141561386,
 		0.010949141561386, 0.010949141561386, 0.010949141561386};
-	static double l15[]={
+	static IssmPDouble l15[]={
 		0.250000000000000, 0.000000000000000, 0.333333333333333, 
 		0.333333333333333, 0.333333333333333, 0.727272727272727, 
@@ -1313,5 +1313,5 @@
 		0.066550153573664, 0.066550153573664, 0.066550153573664, 
 		0.433449846426336, 0.433449846426336, 0.433449846426336};
-	static double l25[]={
+	static IssmPDouble l25[]={
 		0.250000000000000, 0.333333333333333, 0.000000000000000, 
 		0.333333333333333, 0.333333333333333, 0.090909090909091, 
@@ -1319,5 +1319,5 @@
 		0.066550153573664, 0.433449846426336, 0.433449846426336, 
 		0.066550153573664, 0.066550153573664, 0.433449846426336};
-	static double l35[]={
+	static IssmPDouble l35[]={
 		0.250000000000000, 0.333333333333333, 0.333333333333333, 
 		0.000000000000000, 0.333333333333333, 0.090909090909091, 
@@ -1325,5 +1325,5 @@
 		0.433449846426336, 0.066550153573664, 0.433449846426336, 
 		0.066550153573664, 0.433449846426336, 0.066550153573664};
-	static double l45[]={
+	static IssmPDouble l45[]={
 		0.250000000000000, 0.333333333333333, 0.333333333333333, 
 		0.333333333333333, 0.000000000000000, 0.090909090909091, 
@@ -1331,8 +1331,8 @@
 		0.433449846426336, 0.433449846426336, 0.066550153573664, 
 		0.433449846426336, 0.066550153573664, 0.066550153573664};
-	/*}}}2*/
-	/*p= 6, npoint=24  {{{2*/
-
-	static double wgt6[]={
+	/*}}}*/
+	/*p= 6, npoint=24  {{{*/
+
+	static IssmPDouble wgt6[]={
 		0.006653791709695, 0.006653791709695, 0.006653791709695, 
 		0.006653791709695, 0.001679535175887, 0.001679535175887, 
@@ -1343,5 +1343,5 @@
 		0.008035714285714, 0.008035714285714, 0.008035714285714, 
 		0.008035714285714, 0.008035714285714, 0.008035714285714};
-	static double l16[]={
+	static IssmPDouble l16[]={
 		0.356191386222545, 0.214602871259152, 0.214602871259152, 
 		0.214602871259152, 0.877978124396166, 0.040673958534611, 
@@ -1353,5 +1353,5 @@
 		0.269672331458316, 0.603005664791649, 0.269672331458316, 
 		0.603005664791649, 0.269672331458316, 0.603005664791649};
-	static double l26[]={
+	static IssmPDouble l26[]={
 		0.214602871259152, 0.356191386222545, 0.214602871259152, 
 		0.214602871259152, 0.040673958534611, 0.877978124396166, 
@@ -1363,5 +1363,5 @@
 		0.063661001875018, 0.063661001875018, 0.063661001875018, 
 		0.063661001875018, 0.603005664791649, 0.269672331458316};
-	static double l36[]={
+	static IssmPDouble l36[]={
 		0.214602871259152, 0.214602871259152, 0.356191386222545, 
 		0.214602871259152, 0.040673958534611, 0.040673958534611, 
@@ -1373,5 +1373,5 @@
 		0.063661001875018, 0.063661001875018, 0.603005664791649, 
 		0.269672331458316, 0.063661001875018, 0.063661001875018};
-	static double l46[]={
+	static IssmPDouble l46[]={
 		0.214602871259152, 0.214602871259152, 0.214602871259152, 
 		0.356191386222545, 0.040673958534611, 0.040673958534611, 
@@ -1383,20 +1383,20 @@
 		0.603005664791649, 0.269672331458316, 0.063661001875018, 
 		0.063661001875018, 0.063661001875018, 0.063661001875018};
-	/*}}}2*/
-
-	static double* wgtp[MAX_TETRA_SYM_ORD]={wgt1,wgt2,wgt3,wgt4,wgt5,wgt6};
-	static double* l1p [MAX_TETRA_SYM_ORD]={l11 ,l12 ,l13 ,l14 ,l15 ,l16 };
-	static double* l2p [MAX_TETRA_SYM_ORD]={l21 ,l22 ,l32 ,l24 ,l25 ,l26 };
-	static double* l3p [MAX_TETRA_SYM_ORD]={l31 ,l32 ,l33 ,l34 ,l35 ,l36 };
-	static double* l4p [MAX_TETRA_SYM_ORD]={l41 ,l42 ,l43 ,l44 ,l45 ,l46 };
-
-	static int np[MAX_TETRA_SYM_ORD]={sizeof(wgt1 )/sizeof(double),
-		sizeof(wgt2 )/sizeof(double),
-		sizeof(wgt3 )/sizeof(double),
-		sizeof(wgt4 )/sizeof(double),
-		sizeof(wgt5 )/sizeof(double),
-		sizeof(wgt6 )/sizeof(double)};
-
-	//	_printf_(true,"GaussLegendreTetra: iord=%d\n",iord);
+	/*}}}*/
+
+	static IssmPDouble* wgtp[MAX_TETRA_SYM_ORD]={wgt1,wgt2,wgt3,wgt4,wgt5,wgt6};
+	static IssmPDouble* l1p [MAX_TETRA_SYM_ORD]={l11 ,l12 ,l13 ,l14 ,l15 ,l16 };
+	static IssmPDouble* l2p [MAX_TETRA_SYM_ORD]={l21 ,l22 ,l32 ,l24 ,l25 ,l26 };
+	static IssmPDouble* l3p [MAX_TETRA_SYM_ORD]={l31 ,l32 ,l33 ,l34 ,l35 ,l36 };
+	static IssmPDouble* l4p [MAX_TETRA_SYM_ORD]={l41 ,l42 ,l43 ,l44 ,l45 ,l46 };
+
+	static int np[MAX_TETRA_SYM_ORD]={sizeof(wgt1 )/sizeof(IssmPDouble),
+		sizeof(wgt2 )/sizeof(IssmPDouble),
+		sizeof(wgt3 )/sizeof(IssmPDouble),
+		sizeof(wgt4 )/sizeof(IssmPDouble),
+		sizeof(wgt5 )/sizeof(IssmPDouble),
+		sizeof(wgt6 )/sizeof(IssmPDouble)};
+
+	//	_pprintLine_("GaussLegendreTetra: iord=" << iord);
 
 	/*  check to see if Gauss points need to be calculated  */
@@ -1410,9 +1410,9 @@
 		*pngaus=np[iord-1];
 
-		*pl1  = (double *) xmalloc(*pngaus*sizeof(double));
-		*pl2  = (double *) xmalloc(*pngaus*sizeof(double));
-		*pl3  = (double *) xmalloc(*pngaus*sizeof(double));
-		*pl4  = (double *) xmalloc(*pngaus*sizeof(double));
-		*pwgt = (double *) xmalloc(*pngaus*sizeof(double));
+		*pl1  =xNew<IssmPDouble>(*pngaus);
+		*pl2  =xNew<IssmPDouble>(*pngaus);
+		*pl3  =xNew<IssmPDouble>(*pngaus);
+		*pl4  =xNew<IssmPDouble>(*pngaus);
+		*pwgt =xNew<IssmPDouble>(*pngaus);
 
 		for (i=0; i<*pngaus; i++) {
@@ -1430,9 +1430,9 @@
 		*pngaus=nigaus*nigaus*nigaus;
 
-		*pl1  = (double *) xmalloc(*pngaus*sizeof(double));
-		*pl2  = (double *) xmalloc(*pngaus*sizeof(double));
-		*pl3  = (double *) xmalloc(*pngaus*sizeof(double));
-		*pl4  = (double *) xmalloc(*pngaus*sizeof(double));
-		*pwgt = (double *) xmalloc(*pngaus*sizeof(double));
+		*pl1  =xNew<IssmPDouble>(*pngaus);
+		*pl2  =xNew<IssmPDouble>(*pngaus);
+		*pl3  =xNew<IssmPDouble>(*pngaus);
+		*pl4  =xNew<IssmPDouble>(*pngaus);
+		*pwgt =xNew<IssmPDouble>(*pngaus);
 
 		/*  get the gauss points in each direction  */
@@ -1467,10 +1467,10 @@
 			}
 		}
-		xfree((void **)&xwgt );
-		xfree((void **)&xgaus);
+		xDelete<IssmPDouble>(xwgt );
+		xDelete<IssmPDouble>(xgaus);
 	}
-}/*}}}1*/
-/*FUNCTION GaussLobatto{{{1*/
-void GaussLobatto( double** pxgaus, double** pxwgt, int ngaus ) {
+}/*}}}*/
+/*FUNCTION GaussLobatto{{{*/
+void GaussLobatto( IssmPDouble** pxgaus, IssmPDouble** pxwgt, int ngaus ) {
 	/*Gauss-Lobatto quadrature points.
 
@@ -1488,40 +1488,40 @@
 
 	int i;
-	double *alpha,*beta;
-	double left=-1.,right= 1.;
-	double p0l=0.,p0r=0.,p1l=1.,p1r=1.,pm1l,pm1r,det;
+	IssmPDouble *alpha,*beta;
+	IssmPDouble left=-1.,right= 1.;
+	IssmPDouble p0l=0.,p0r=0.,p1l=1.,p1r=1.,pm1l,pm1r,det;
 
 	/*p= 1, npoint= 1 (Gauss-Legendre)*/
-	static double wgt1[]={2.000000000000000};
-	static double xi1[]={0.000000000000000};
+	static IssmPDouble wgt1[]={2.000000000000000};
+	static IssmPDouble xi1[]={0.000000000000000};
 
 	/*p= 1, npoint= 2*/
-	static double wgt2[]={1.000000000000000, 1.000000000000000};
-	static double xi2[]={-1.000000000000000, 1.000000000000000};
+	static IssmPDouble wgt2[]={1.000000000000000, 1.000000000000000};
+	static IssmPDouble xi2[]={-1.000000000000000, 1.000000000000000};
 
 	/*p= 3, npoint= 3*/
-	static double wgt3[]={0.333333333333333, 1.333333333333333, 0.333333333333333};
-	static double xi3[]={-1.000000000000000, 0.000000000000000, 1.000000000000000};
+	static IssmPDouble wgt3[]={0.333333333333333, 1.333333333333333, 0.333333333333333};
+	static IssmPDouble xi3[]={-1.000000000000000, 0.000000000000000, 1.000000000000000};
 
 	/*p= 5, npoint= 4*/
-	static double wgt4[]={0.166666666666667, 0.833333333333333, 0.833333333333333, 0.166666666666667};
-	static double xi4[]={-1.000000000000000,-0.447213595499958, 0.447213595499958, 1.000000000000000};
+	static IssmPDouble wgt4[]={0.166666666666667, 0.833333333333333, 0.833333333333333, 0.166666666666667};
+	static IssmPDouble xi4[]={-1.000000000000000,-0.447213595499958, 0.447213595499958, 1.000000000000000};
 
 	/*p= 7, npoint= 5*/
-	static double wgt5[]={0.100000000000000, 0.544444444444444, 0.711111111111111, 0.544444444444444, 0.100000000000000};
-	static double xi5[]={-1.000000000000000,-0.654653670707977, 0.000000000000000, 0.654653670707977, 1.000000000000000};
-
-	static double* wgtp[MAX_LINE_GLOB_PTS]={wgt1 ,wgt2 ,wgt3 ,wgt4 ,wgt5 };
-	static double* xip [MAX_LINE_GLOB_PTS]={xi1  ,xi2  ,xi3  ,xi4  ,xi5  };
-
-	static int np[MAX_LINE_GLOB_PTS]={sizeof(wgt1 )/sizeof(double),
-		sizeof(wgt2 )/sizeof(double),
-		sizeof(wgt3 )/sizeof(double),
-		sizeof(wgt4 )/sizeof(double),
-		sizeof(wgt5 )/sizeof(double)};
-
-	//	_printf_(true,"Gauss-Lobatto recurrence coefficients ngaus=%d\n",ngaus);
-	*pxgaus = (double *) xmalloc(ngaus*sizeof(double));
-	*pxwgt  = (double *) xmalloc(ngaus*sizeof(double));
+	static IssmPDouble wgt5[]={0.100000000000000, 0.544444444444444, 0.711111111111111, 0.544444444444444, 0.100000000000000};
+	static IssmPDouble xi5[]={-1.000000000000000,-0.654653670707977, 0.000000000000000, 0.654653670707977, 1.000000000000000};
+
+	static IssmPDouble* wgtp[MAX_LINE_GLOB_PTS]={wgt1 ,wgt2 ,wgt3 ,wgt4 ,wgt5 };
+	static IssmPDouble* xip [MAX_LINE_GLOB_PTS]={xi1  ,xi2  ,xi3  ,xi4  ,xi5  };
+
+	static int np[MAX_LINE_GLOB_PTS]={sizeof(wgt1 )/sizeof(IssmPDouble),
+		sizeof(wgt2 )/sizeof(IssmPDouble),
+		sizeof(wgt3 )/sizeof(IssmPDouble),
+		sizeof(wgt4 )/sizeof(IssmPDouble),
+		sizeof(wgt5 )/sizeof(IssmPDouble)};
+
+	//	_pprintLine_("Gauss-Lobatto recurrence coefficients ngaus=" << ngaus);
+	*pxgaus =xNew<IssmPDouble>(ngaus);
+	*pxwgt  =xNew<IssmPDouble>(ngaus);
 
 	/*  check to see if Gauss points need to be calculated  */
@@ -1539,6 +1539,6 @@
 
 		/*  calculate the Gauss points using recurrence relations  */
-		alpha=(double *) xmalloc(ngaus*sizeof(double));
-		beta =(double *) xmalloc(ngaus*sizeof(double));
+		alpha=xNew<IssmPDouble>(ngaus);
+		beta =xNew<IssmPDouble>(ngaus);
 
 		/*  calculate the Legendre recurrence coefficients  */
@@ -1575,11 +1575,11 @@
 		/*  calculate the Gauss points  */
 		GaussRecur(*pxgaus, *pxwgt, ngaus, alpha, beta );
-		xfree((void **)&beta );
-		xfree((void **)&alpha);
+		xDelete<IssmPDouble>(beta );
+		xDelete<IssmPDouble>(alpha);
 	}
 
-}/*}}}1*/
-/*FUNCTION GaussRecur{{{1*/
-void GaussRecur( double* zero, double* weight, int n, double* alpha, double* beta ) {
+}/*}}}*/
+/*FUNCTION GaussRecur{{{*/
+void GaussRecur( IssmPDouble* zero, IssmPDouble* weight, int n, IssmPDouble* alpha, IssmPDouble* beta ) {
 	/*Gauss quadrature points from recursion coefficients.
 	 *
@@ -1589,6 +1589,6 @@
 	/*Intermediaries*/
 	int i,j,k,l,m,ii,mml,iter;
-	double p,g,r,s,c,f,b;
-	double* work;
+	IssmPDouble p,g,r,s,c,f,b;
+	IssmPDouble* work;
 
 	if (n==1){
@@ -1598,5 +1598,5 @@
 	}
 
-	work=(double*)xmalloc(n*sizeof(double));
+	work=xNew<IssmPDouble>(n);
 
 	zero[0]  =alpha[0];
@@ -1669,6 +1669,6 @@
 		} while (iter < MAX_GAUS_ITER);
 		if (iter >= MAX_GAUS_ITER) {
-			xfree((void **)&work);
-			_error_("%s%i"," Max iterations exceeded for l=",MAX_GAUS_ITER);
+			xDelete<IssmPDouble>(work);
+			_error2_("Max iterations exceeded for l=" << MAX_GAUS_ITER);
 		}
 	}
@@ -1698,11 +1698,11 @@
 
 	/*Cleanup*/
-	xfree((void **)&work);
-
-}/*}}}1*/
+	xDelete<IssmPDouble>(work);
+
+}/*}}}*/
 
 /*Element Gauss points TO BE REMOVED*/
-/*FUNCTION gaussQuad{{{1*/
-void gaussQuad( double** pxgaus, double** pxwgt, double** pegaus, double** pewgt, int nigaus, int njgaus ) { 
+/*FUNCTION gaussQuad{{{*/
+void gaussQuad( IssmPDouble** pxgaus, IssmPDouble** pxwgt, IssmPDouble** pegaus, IssmPDouble** pewgt, int nigaus, int njgaus ) {
 	/*Gauss quadrature points for the quadrilaterial.*/
 
@@ -1710,7 +1710,7 @@
 	GaussLegendreLinear(pxgaus, pxwgt, nigaus);
 	GaussLegendreLinear(pegaus, pewgt, njgaus);
-}/*}}}1*/
-/*FUNCTION gaussHexa{{{1*/
-void gaussHexa( double** pxgaus, double** pxwgt, double** pegaus, double** pewgt, double** pzgaus, double** pzwgt, int nigaus, int njgaus, int nkgaus ) {
+}/*}}}*/
+/*FUNCTION gaussHexa{{{*/
+void gaussHexa( IssmPDouble** pxgaus, IssmPDouble** pxwgt, IssmPDouble** pegaus, IssmPDouble** pewgt, IssmPDouble** pzgaus, IssmPDouble ** pzwgt, int nigaus, int njgaus, int nkgaus ) {
 	/*Gauss quadrature points for the hexahedron.*/
 
@@ -1719,3 +1719,3 @@
 	GaussLegendreLinear(pegaus, pewgt, njgaus);
 	GaussLegendreLinear(pzgaus, pzwgt, nkgaus);
-}/*}}}1*/
+}/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/GaussPoints.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/GaussPoints.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/GaussPoints.h	(revision 12878)
@@ -3,20 +3,21 @@
  */ 
 
+#include "../../include/types.h"
 #ifndef _GAUSSPOINTS_H
 #define _GAUSSPOINTS_H
 
 #define MAX_LINE_GAUS_PTS    4
-void GaussLegendreLinear( double** pxgaus, double** pxwgt, int ngaus ); 
+void GaussLegendreLinear(IssmPDouble** pxgaus, IssmPDouble** pxwgt, int ngaus);
 #define MAX_TRIA_SYM_ORD    20
-void GaussLegendreTria( int* pngaus, double** pl1, double** pl2, double** pl3, double** pwgt, int iord );
+void GaussLegendreTria(int* pngaus, IssmPDouble** pl1, IssmPDouble** pl2, IssmPDouble** pl3, IssmPDouble** pwgt, int iord);
 #define MAX_TETRA_SYM_ORD    6
-void GaussLegendreTetra( int* pngaus, double** pl1, double** pl2, double** pl3, double** pl4, double** pwgt, int iord );
+void GaussLegendreTetra(int* pngaus, IssmPDouble** pl1, IssmPDouble** pl2, IssmPDouble** pl3, IssmPDouble** pl4, IssmPDouble** pwgt, int iord);
 #define MAX_LINE_GLOB_PTS    5
-void GaussLobatto( double** pxgaus, double** pxwgt, int ngaus ); 
+void GaussLobatto(IssmPDouble** pxgaus, IssmPDouble** pxwgt, int ngaus);
 #define MAX_GAUS_ITER   30
-void GaussRecur( double* zero, double* weight, int n, double* alpha, double* beta );
+void GaussRecur(IssmPDouble* zero, IssmPDouble* weight, int n, IssmPDouble* alpha, IssmPDouble* beta);
 
-void gaussQuad( double** pxgaus, double** pxwgt, double** pegaus, double** pewgt, int nigaus, int njgaus );
-void gaussHexa( double** pxgaus, double** pxwgt, double** pegaus, double** pewgt, double** pzgaus, double** pzwgt, int nigaus, int njgaus, int nkgaus );
+void gaussQuad(IssmPDouble** pxgaus, IssmPDouble** pxwgt, IssmPDouble** pegaus, IssmPDouble** pewgt, int nigaus, int njgaus);
+void gaussHexa(IssmPDouble** pxgaus, IssmPDouble** pxwgt, IssmPDouble** pegaus, IssmPDouble** pewgt, IssmPDouble** pzgaus, IssmPDouble ** pzwgt, int nigaus, int njgaus, int nkgaus);
 
 #endif
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/IsInputConverged.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/IsInputConverged.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/IsInputConverged.cpp	(revision 12878)
@@ -12,19 +12,19 @@
 #endif
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
-void IsInputConverged(double* peps, Input** new_inputs,Input** old_inputs,int num_inputs,int criterion_enum){
+void IsInputConverged(IssmDouble* peps, Input** new_inputs,Input** old_inputs,int num_inputs,int criterion_enum){
 
 	int i,j;
 
 	/*output: */
-	double eps;
+	IssmDouble eps;
 	
 	/*intermediary: */
-	double *newvalues     = NULL;
-	double *oldvalues     = NULL;
+	IssmDouble *newvalues     = NULL;
+	IssmDouble *oldvalues     = NULL;
 	int     num_values;
-	double  ndu        = 0;
-	double  nu         = 0;
+	IssmDouble  ndu        = 0;
+	IssmDouble  nu         = 0;
 
 	if(criterion_enum==RelativeEnum){
@@ -50,8 +50,8 @@
 
 		/*now, compute eps: */
-		if(nu)eps=ndu/nu;
+		if(reCast<bool>(nu))eps=ndu/nu;
 		else eps=0;
 	}
-	else _error_("%s%s%s"," convergence criterion ",EnumToStringx(criterion_enum)," not supported yet!");
+	else _error2_("convergence criterion " << EnumToStringx(criterion_enum) << " not supported yet!");
 
 	/*Assign output pointers:*/
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/OptimalSearch.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/OptimalSearch.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/OptimalSearch.cpp	(revision 12878)
@@ -10,5 +10,5 @@
 
 #include "./numerics.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../io/io.h"
 #include "../../include/include.h"
@@ -16,15 +16,15 @@
 #include <float.h>
 
-void OptimalSearch(double* psearch_scalar,double* pJ,OptPars* optpars,double (*f)(double,OptArgs*), OptArgs* optargs){
+void OptimalSearch(IssmDouble* psearch_scalar,IssmDouble* pJ,OptPars* optpars,IssmDouble (*f)(IssmDouble,OptArgs*), OptArgs* optargs){
 
 	/* This routine is optimizing a given function*/
 
 	/*function values: */
-	double fx1,fx2,fxbest;
-	double x1,x2,xmin,xbest;
+	IssmDouble fx1,fx2,fxbest;
+	IssmDouble x1,x2,xmin,xbest;
 
 	/*tolerances: */
-	double seps;
-	double tolerance=1.e-4;
+	IssmDouble seps;
+	IssmDouble tolerance=1.e-4;
 	int    maxiter;
 
@@ -41,7 +41,10 @@
 	//get the value of the function at the first boundary
 	fx1= (*f)(x1,optargs);
-	if (isnan(fx1)) _error_("Function evaluation returned NaN");
-	_printf_(VerboseControl(),"\n        Iteration         x           f(x)       Tolerance\n\n");
-	_printf_(VerboseControl(),"        %s    %12.6g  %12.6g  %s","   N/A",x1,fx1,"         N/A\n");
+	if (xIsNan<IssmDouble>(fx1)) _error2_("Function evaluation returned NaN");
+	cout<<setprecision(5);
+	if(VerboseControl()) _pprintLine_("");
+	if(VerboseControl()) _pprintLine_("       Iteration         x           f(x)       Tolerance");
+	if(VerboseControl()) _pprintLine_("");
+	if(VerboseControl()) _pprintLine_("           N/A    "<<setw(12)<<x1<<"  "<<setw(12)<<fx1<<"           N/A");
 
 	//update tolerances
@@ -54,14 +57,15 @@
 		iter++;
 		fx2 = (*f)(x2,optargs);
-		if (isnan(fx2)) _error_("Function evaluation returned NaN");
-		_printf_(VerboseControl(),"         %5i    %12.6g  %12.6g  %12.6g\n",iter,x2,fx2,fabs(x2-x1)>fabs(fx2-fx1)?fabs(fx2-fx1):fabs(x2-x1));
+		if (xIsNan<IssmDouble>(fx2)) _error2_("Function evaluation returned NaN");
+		if(VerboseControl())
+		 _pprintLine_("         "<<setw(5)<<iter<<"    "<<setw(12)<<x2<<"  "<<setw(12)<<fx2<<"  "<<(fabs(x2-x1)>fabs(fx2-fx1)?fabs(fx2-fx1):fabs(x2-x1)));
 
 		//Stop the optimization?
 		if ((fabs(x2-x1)+seps)<tolerance || (fabs(fx2-fx1)+seps)<tolerance){
-			_printf_(VerboseControl(),"      %s%g\n","optimization terminated: the current x satisfies the termination criteria using 'tolx' of " ,tolerance);
+			if(VerboseControl()) _pprintLine_("      " << "optimization terminated: the current x satisfies the termination criteria using 'tolx' of "  << tolerance);
 			loop=false;
 		}
 		else if (iter>=maxiter){
-			_printf_(VerboseControl(),"      %s\n","exiting: Maximum number of iterations has been exceeded  - increase 'maxiter'\n");
+			if(VerboseControl()) _pprintLine_("      " << "exiting: Maximum number of iterations has been exceeded  - increase 'maxiter'");
 			loop=false;
 		}
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/OptionsFromAnalysis.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/OptionsFromAnalysis.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/OptionsFromAnalysis.cpp	(revision 12878)
@@ -9,5 +9,7 @@
 #endif
 
-#include "../../objects/objects.h"
+#include <cstring>
+
+#include "../../classes/objects/objects.h"
 #include "../../Container/Parameters.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
@@ -20,5 +22,5 @@
 	/*intermediary: */
 	int     dummy;
-	double* analyses=NULL;
+	IssmDouble* analyses=NULL;
 	char**  strings=NULL;
 	char*   string=NULL;
@@ -55,20 +57,18 @@
 	if (found==-1){
 		/*ok, we did not find anything, this is not good! error out: */
-		_error_("%s%s","could find neither a default analysis  nor analysis ",EnumToStringx(analysis_type));
+		_error2_("could find neither a default analysis  nor analysis " << EnumToStringx(analysis_type));
 	}
 
 	/*ok, grab the option string: */
-	outstring=(char*)xmalloc((strlen(strings[found])+1)*sizeof(char));
+	outstring=xNew<char>(strlen(strings[found])+1);
 	strcpy(outstring,strings[found]);
 
 	/*Free ressources*/
-	xfree((void**)&analyses);
+	xDelete<IssmDouble>(analyses);
 	for(i=0;i<numanalyses;i++){
 		string=strings[i];
-		xfree((void**)&string);
+		xDelete<char>(string);
 	}
-	xfree((void**)&strings);
-
-
+	xDelete<char*>(strings);
 	return outstring;
 }
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/PetscOptionsFromAnalysis.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/PetscOptionsFromAnalysis.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/PetscOptionsFromAnalysis.cpp	(revision 12878)
@@ -9,5 +9,5 @@
 #endif
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Parameters.h"
 #include "../../toolkits/toolkits.h"
@@ -39,4 +39,4 @@
 
 	/*Free ressources:*/
-	xfree((void**)&options);
+	xDelete<char>(options);
 }
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/Synchronize.sh
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/Synchronize.sh	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/Synchronize.sh	(revision 12878)
@@ -8,5 +8,5 @@
 #Get all lines of Verbosity.cpp
 cat Verbosity.h |  grep "bool Verbose" | awk '{print $2}' | sed -e "s/(/ /" | awk '{print $1}' | awk '{ printf "%s %s\n", NR, $0 }' >temp
-#Build header of Verbosity.cpp {{{1
+#Build header of Verbosity.cpp {{{
 cat <<END > Verbosity.cpp
 /*
@@ -127,5 +127,5 @@
 done
 
-#Add footer of Verbosity.cpp{{{1
+#Add footer of Verbosity.cpp{{{
 cat <<END >> Verbosity.cpp
 
@@ -135,5 +135,5 @@
 void SetVerbosityLevel(int level){
 
-	if(level<0) _error_("vebosity level should be a positive integer (user provided %i)",level);
+	if(level<0) _error2_("vebosity level should be a positive integer (user provided " << level << ")");
 
 	verbositylevel = level;
@@ -147,5 +147,5 @@
 END
 #}}}
-#Complete verbose.m {{{1
+#Complete verbose.m {{{
 VERBOSEPATH="$ISSM_DIR/src/m/classes/verbose.m"
 cat $VERBOSEPATH  | sed "/%BEGINFIELDS/,$ d"  > temp_begin
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/UnitConversion.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/UnitConversion.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/UnitConversion.cpp	(revision 12878)
@@ -3,5 +3,5 @@
  */ 
 
-/*headers {{{1*/
+/*headers {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -11,14 +11,14 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
 #include "../../shared/shared.h"
 
-double UnitConversionScaleFactor(int type_enum);
+IssmDouble UnitConversionScaleFactor(int type_enum);
 /*}}}*/
 
-void UnitConversion(double* values, int numvalues,int direction_enum, int type_enum){
+void UnitConversion(IssmDouble* values, int numvalues,int direction_enum, int type_enum){
 
-	double scale;
+	IssmDouble scale;
 	int i;
 
@@ -29,9 +29,9 @@
 	if(direction_enum==IuToExtEnum) for(i=0;i<numvalues;i++)values[i]=values[i]*scale; 
 	else if(direction_enum==ExtToIuEnum) for(i=0;i<numvalues;i++)values[i]=values[i]/scale; 
-	else _error_(" wrong direction for unit conversion, either IuToExtEnum or ExtToIuEnum. ");
+	else _error2_("wrong direction for unit conversion, either IuToExtEnum or ExtToIuEnum. ");
 
 }
 
-double UnitConversion(double value, int direction_enum, int type_enum){
+IssmDouble UnitConversion(IssmDouble value, int direction_enum, int type_enum){
 
 	UnitConversion(&value,1,direction_enum,type_enum);
@@ -41,9 +41,9 @@
 
 
-double UnitConversionScaleFactor(int type_enum){
+IssmDouble UnitConversionScaleFactor(int type_enum){
 
-	double yts=365.0*24.0*3600.0;
+	IssmDouble yts=365.0*24.0*3600.0;
 	
-	double scale;
+	IssmDouble scale;
 	switch(type_enum){
 		case TimesteppingStartTimeEnum:              scale=1.0/yts;break; //yr
@@ -66,6 +66,13 @@
 		case SurfaceforcingsPrecipitationEnum:       scale=yts;break; //m/yr
 		case SurfaceforcingsMassBalanceEnum:         scale=yts;break; //m/yr
+		case SurfaceforcingsSmbPosMaxEnum:				scale=yts;break; //m/yr
+		case SurfaceforcingsSmbPosMinEnum:				scale=yts;break; //m/yr
+		case SurfaceforcingsAPosEnum:						scale=yts;break; //m/yr
+		case SurfaceforcingsBPosEnum:						scale=yts;break; //m/yr
+		case SurfaceforcingsANegEnum:						scale=yts;break; //m/yr
+		case SurfaceforcingsBNegEnum:						scale=yts;break; //m/yr
 		case MisfitEnum:                             scale=pow(yts,2);break; //(m/yr)^2
-		case MassFluxEnum:                           scale=pow((double)10,-12)*yts;break; // (GigaTon/year)
+		case MassFluxEnum:                           scale=pow((IssmDouble)10,-12)*yts;break; // (GigaTon/year)
+		case TotalSmbEnum:                           scale=pow((IssmDouble)10,-12)*yts;break; // (GigaTon/year)
 		default: scale=1.0; break;
 	}
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/Verbosity.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/Verbosity.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/Verbosity.cpp	(revision 12878)
@@ -34,5 +34,5 @@
 void SetVerbosityLevel(int level){
 
-	if(level<0) _error_("vebosity level should be a positive integer (user provided %i)",level);
+	if(level<0) _error2_("vebosity level should be a positive integer (user provided " << level << ")");
 
 	verbositylevel = level;
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/XZvectorsToCoordinateSystem.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/XZvectorsToCoordinateSystem.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/XZvectorsToCoordinateSystem.cpp	(revision 12878)
@@ -5,12 +5,12 @@
 #include <math.h>
 
-void XZvectorsToCoordinateSystem(double* T,double* xzvectors){
+void XZvectorsToCoordinateSystem(IssmDouble* T,IssmDouble* xzvectors){
 
 	int		i,j;
-	double	x[3],y[3],z[3];
-	double	x_norm, y_norm, z_norm;
+	IssmDouble	x[3],y[3],z[3];
+	IssmDouble	x_norm, y_norm, z_norm;
 
 	for(i=0;i<6;i++){
-		if(isnan(xzvectors[i])){
+		if(xIsNan<IssmDouble>(xzvectors[i])){
 			/*At least one NaN found: default to Id*/
 			T[0*3+0] = 1.0;	T[0*3+1] = 0.0;	T[0*3+2] = 0.0;
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/cross.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/cross.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/cross.cpp	(revision 12878)
@@ -9,5 +9,7 @@
 #endif
 
-void cross(double* result,double* vector1,double* vector2){
+#include "../../include/include.h"
+
+void cross(IssmDouble* result,IssmDouble* vector1,IssmDouble* vector2){
 
 	/*result,vector1 and vector2 are all assumed to be of size 3: */
